<?xml version="1.0" encoding="UTF-8"?>

<project name="SampleProject" default="runTests" basedir=".">

	<property name="build.dir" value="${basedir}/bin/build"/>
	<property name="lib.dir" value="${basedir}/lib"/>
	<property name="src.dir" value="${basedir}/test-src"/>
	<property name="config.dir" value="${basedir}/TestNGSuites"/>
	<property name="testngfail.dir" value="${basedir}/TestNG-Output"/>
	<property environment="env"/>
	<property name="ANT_HOME" value="${env.ANT_HOME}"/>
	<property name="aspectj.version" value="1.8.4"/>
	<property name="user.java.version" value="1.7"/>
	<property name="build.log.dir" location="${basedir}/bin/buildlogs"/>
	<property name="Reportdir" location="${basedir}/Automation Reports/LatestResults" />
	<!--<target name="setSikulidir">
 	<exec dir="." executable="cmd" outputproperty="result">
		<arg line="/c SET ProgramFiles(x86)"/>
	</exec>
	<condition property="sikuli.dir" value="${basedir}/SikuliX64" else="${basedir}/SikuliX86">
		<contains string="${result}" substring="Program Files (x86)"/>
	</condition>
</target>-->

	<target name="setClassPath" >
		<echo message="Setting CLASSPATH....."/>
		<path id="classpath_jars">
			<pathelement path="${basedir}/" />
			<fileset dir="${lib.dir}" includes="*.jar" />
		</path>
		<pathconvert pathsep=":" property="test.classpath" refid="classpath_jars" />
		<echo message="CLASSPATH set...."/>
	</target>



	<target name="loadTestNG" depends="setClassPath">
		<echo message="TestNG loading........"/>
		<taskdef resource="testngtasks" classpath="${test.classpath}"/>
	</target>


	<target name="init">
		<echo message="Creating build directories.........."/>
		<mkdir dir="${build.dir}"/>
		<tstamp>
			<format property="timestamp" pattern="dd-MM-yyyy_(HH-mm-ss)"/>
		</tstamp>

		<mkdir dir="${build.log.dir}"/>
		<property name="build.log.filename" value="build_${timestamp}.log"/>
		<record name="${build.log.dir}/${build.log.filename}" loglevel="verbose" append="false"/>
		<echo message="Build logs can be found at ${build.log.filename}"/>
	</target>


	<target name="clean">
		<echo message="Deleting existing build directory"/>
		<delete dir="${build.dir}"/>
		<delete dir="${build.log.dir}"/>
	</target>


	<target name="compile" depends="clean,init,setClassPath,loadTestNG">
		<echo message="Compiling to ${build.dir}"/>
		<javac source="${user.java.version}" target="${user.java.version}" destdir="${build.dir}" srcdir="${src.dir}" classpath="${test.classpath}" debug="true" debuglevel="lines,vars,source"  includeantruntime="false" />
	</target>



	<target name="Copylog">
		<echo message="Copying log4j configuration............"/>
		<copy todir="${build.dir}">
			<fileset dir="${src.dir}">
				<include name="log4j.xml"/>
			</fileset>
		</copy>
	</target>



	<target name="runTests" depends="compile,Copylog,Ant-TryCatch">
		<trycatch reference="exception_ref">
			<try>
				<echo message="Running TestNG Suite file............."/>
				<property name ="archive.name" value="Automation Reports/Reports" />
				<testng classpath="${test.classpath}:${build.dir}" outputdir="${archive.name}"
			            haltonfailure="true"
			            useDefaultListeners="false"
			            listeners="org.uncommons.reportng.HTMLReporter,org.uncommons.reportng.JUnitXMLReporter,org.testng.reporters.XMLReporter">
					<jvmarg value="-javaagent:${lib.dir}/aspectjweaver-${aspectj.version}.jar"/>
					<xmlfileset dir="${config.dir}" includes="TestNG.xml"/>
					<sysproperty key="org.uncommons.reportng.title" value="Sample API Report"/>
				</testng>
				<antcall target="LaunchReportNGReports">
				</antcall>
			</try>
			<catch>
				<property name="exception" refid="exception_ref" />
				<property name="message" value="Error in trycatch block:${line.separator}${exception}" />
				<echo message="${message}" />
				<antcall target="LaunchReportNGReports">
				</antcall>
			</catch>
		</trycatch>
	</target>

	<target name="LaunchReportNGReports">
		<echo message="move log folder to LatestResults..............."/>
		<move todir="${basedir}/Automation Reports/LatestResults">
			<filelist dir="${basedir}/Automation Reports">
				<file name="Log.log"/>
			</filelist>
			<fileset dir="${basedir}/Automation Reports/Reports"/>
		</move>

		<echo message="ReportNG reports are generated..."/>
		<echo message="Launching ReportNG reports with default browser..............."/>
		<script language="javascript">
			<![CDATA[
	            var location = "file:///"+project.getProperty("Reportdir").toString().replaceAll("\\\\","/")+"/html/index.html";
	            location = location.toString().replace(/ /g, "%20");
	             // show URL - copy and paste into browser address bar to test location
	            //println(location);
	            var uriLocation = java.net.URI.create(location);
	            var desktop = java.awt.Desktop.getDesktop();
	            desktop.browse(uriLocation);
	        ]]>
		</script>


		<!-- to run in specified browser....works only in windows
	<exec executable="${browser}" spawn="yes">	       
		<arg line="${basedir}/Automation Reports/LatestResults/html/index.html"/>	    	
	</exec>-->
	</target>

	<target name="Ant-TryCatch">
		<taskdef resource="net/sf/antcontrib/antcontrib.properties">
			<classpath>
				<pathelement location="${basedir}/lib/ant-contrib-0.6.jar"/>
			</classpath>
		</taskdef>
	</target>


	<target name="SendMail" depends="runTests">
		<zip destfile="${basedir}/Automation Reports/LatestResults/Reports.zip"
	   basedir="${basedir}/Automation Reports/LatestResults"
	   includes="html/**,Screenshots/**"
	/>
		<mail tolist="blackthornzenqa@gmail.com" from="blackthornzenqa@gmail.com" subject="Selenium Automation Results" mailhost="pop.gmail.com" mailport="587" ssl="true" user="blackthornzenqa@gmail.com" password="second@123">
			<message>The automation build has completed successfully. Please find enclosed ReportNG Report</message>
			<attachments>
				<fileset dir="${basedir}/Automation Reports/LatestResults">
					<include name="**/*.zip"/>
				</fileset>
			</attachments>
		</mail>
	</target>

	<!--<target name="TestNGReport" depends="loadTestNG">
        	
	<delete dir="${basedir}/TestNGReports">      
	</delete>    	
	<mkdir dir="${basedir}/TestNGReports">   	
	</mkdir>    	
	<xslt in="${basedir}/TestNG-Output/testng-results.xml" style="${basedir}/Resources/testng-results.xsl" out="${basedir}/TestNGReports/index.html">   	
		<param expression="${basedir}/TestNGReports" name="testNgXslt.outputDir" />		        
		<param expression="true" name="testNgXslt.sortTestCaseLinks" />		        
		<param expression="FAIL,SKIP,PASS,CONF,BY_CLASS" name="testNgXslt.testDetailsFilter" />		        
		<param expression="true" name="testNgXslt.showRuntimeTotals" />		
		<param expression="ZenQA Selenium TestNG Report" name="testNgXslt.reportTitle" />
			       	
		<classpath refid="classpath_jars"/>	       
	</xslt>    
	<echo message="TestNG reports are generated..."/>  
	<echo message="Launching TestNG reports with default browser..............."/>    
	<exec executable="${browser}" spawn="yes">	       
		<arg line="${basedir}/TestNGReports/index.html"/>	    	
	</exec>
	
 </target>-->



	<!--
<target name="RunAndViewReport" depends="report" >	    
	<exec executable="${browser}" spawn="yes">	       
		<arg line="${basedir}/Reports/index.html"/>	    	
	</exec>       
</target>
	
	

<target name="junit-report">	
	<delete dir="${basedir}/Reports/Junit"></delete>		        
	<mkdir dir="${basedir}/Reports/Junit"></mkdir>		        
	<junitreport todir="${basedir}/Reports/Junit">
		<fileset dir="${basedir}/test-output">		                
			<include name="*/*.xml">		           
			</include>
		</fileset>		            
		<report format="noframes" todir="${basedir}/Reports/Junit">	        
		</report>		
	</junitreport>	
</target>
	
	


<target description="Generates and send testng test reports" name="sendreport">	  
	<zip destfile="${basedir}/Reports/Reports.zip" basedir="${basedir}/Reports"/>	  
	<mail mailhost="smtp.gmail.com" mailport="465" password="zenqatest" ssl="true" subject="Test build" user="cqauser@gmail.com">	     
		<from address="cqauser@gmail.com"></from>	     
		<replyto address="cqauser@gmail.com"></replyto>	     
		<to address="zenqatest@gmail.com"></to>	     
		<message>The Test nightly build has completed</message>	     
		<attachments>	       
			<fileset dir="${basedir}/Reports">	          
				<include name="**/*.zip"></include>	      
			</fileset>	     
		</attachments>	  
	</mail>	
</target>
	
    

<target name="sendMail">
 	
	<zip destfile="${basedir}/Reports/Reports.zip" basedir="${basedir}/Reports"/>	        
	<mail mailhost="smtp.gmail.com" mailport="465" subject="Notification of gmail build" ssl="false" user="cqauser@gmail.com" password="zenqatest">	            
		<from address="cqauser@gmail.com"/>	            
		<to address="ramya@zenqa.com"/>	            
		<message>The build has finished. A details report of this build is attached</message>	            
		<attachments>	                
			<fileset dir="Reports">	                   
				<include name="**/*.zip"/>	                
			</fileset>	            
		</attachments>	          
	</mail>
</target>	

-->
</project>